package java.security;

import java.util.Iterator;
import java.util.Arrays;
import java.util.Vector;
import java.io.Serializable;

@Deprecated
public abstract class Identity implements Principal, Serializable
{
    private static final long serialVersionUID = 3609922007826600659L;
    private String name;
    private PublicKey publicKey;
    String info;
    IdentityScope scope;
    Vector<Certificate> certificates;
    
    protected Identity() {
        this("restoring...");
    }
    
    public Identity(String s, IdentityScope scope) throws KeyManagementException {
        this(s);
        if (scope != null) {
            scope.addIdentity(this);
        }
        this.scope = scope;
    }
    
    public Identity(String name) {
        this.info = "No further information available.";
        this.name = name;
    }
    
    @Override
    public final String getName() {
        return this.name;
    }
    
    public final IdentityScope getScope() {
        return this.scope;
    }
    
    public PublicKey getPublicKey() {
        return this.publicKey;
    }
    
    public void setPublicKey(PublicKey publicKey) throws KeyManagementException {
        check("setIdentityPublicKey");
        this.publicKey = publicKey;
        this.certificates = new Vector();
    }
    
    public void setInfo(String info) {
        check("setIdentityInfo");
        this.info = info;
    }
    
    public String getInfo() {
        return this.info;
    }
    
    public void addCertificate(Certificate obj) throws KeyManagementException {
        check("addIdentityCertificate");
        if (this.certificates == null) {
            this.certificates = new Vector();
        }
        if (this.publicKey != null) {
            if (!this.keyEquals(this.publicKey, obj.getPublicKey())) {
                throw new KeyManagementException("public key different from cert public key");
            }
        }
        else {
            this.publicKey = obj.getPublicKey();
        }
        this.certificates.addElement(obj);
    }
    
    private boolean keyEquals(PublicKey publicKey, PublicKey publicKey2) {
        String format = publicKey.getFormat();
        String format2 = publicKey2.getFormat();
        return !(format == null ^ format2 == null) && (format == null || format2 == null || format.equalsIgnoreCase(format2)) && Arrays.equals(publicKey.getEncoded(), publicKey2.getEncoded());
    }
    
    public void removeCertificate(Certificate obj) throws KeyManagementException {
        check("removeIdentityCertificate");
        if (this.certificates != null) {
            this.certificates.removeElement(obj);
        }
    }
    
    public Certificate[] certificates() {
        if (this.certificates == null) {
            return new Certificate[0];
        }
        Certificate[] anArray = new Certificate[this.certificates.size()];
        this.certificates.copyInto(anArray);
        return anArray;
    }
    
    @Override
    public final boolean equals(Object o) {
        if (o == this) {
            return true;
        }
        if ((o instanceof Identity)) {
            Identity identity = (Identity)o;
            return this.fullName().equals(identity.fullName()) || this.identityEquals(identity);
        }
        return false;
    }
    
    protected boolean identityEquals(Identity identity) {
        return this.name.equalsIgnoreCase(identity.name) && !(this.publicKey == null ^ identity.publicKey == null) && (this.publicKey == null || identity.publicKey == null || this.publicKey.equals(identity.publicKey));
    }
    
    String fullName() {
        String str = this.name;
        if (this.scope != null) {
            str = str + "." + this.scope.getName();
            return str;
        }
        return str;
    }
    
    @Override
    public String toString() {
        check("printIdentity");
        String str = this.name;
        if (this.scope != null) {
            str = str + "[" + this.scope.getName() + "]";
            return str;
        }
        return str;
    }
    
    public String toString(boolean b) {
        String str = this.toString();
        if (b) {
            String string = str + "\n" + this.printKeys() + "\n" + this.printCertificates();
            if (this.info != null) {
                str = string + "\n\t" + this.info;
            }
            else {
                str = string + "\n\tno additional information available.";
            }
        }
        return str;
    }
    
    String printKeys() {
        if (this.publicKey != null) {
            return "\tpublic key initialized";
        }
        return "\tno public key";
    }
    
    String printCertificates() {
        String str = "";
        if (this.certificates == null) {
            return "\tno certificates";
        }
        String str2 = str + "\tcertificates: \n";
        int n = 1;
        for (Certificate certificate : this.certificates) {
            str2 = str2 + "\tcertificate " + n++ + "\tfor  : " + certificate.getPrincipal() + "\n" + "\t\t\tfrom : " + certificate.getGuarantor() + "\n";
        }
        return str2;
    }
    
    @Override
    public int hashCode() {
        return this.name.hashCode();
    }
    
    private static void check(String target) {
        SecurityManager securityManager = System.getSecurityManager();
        if (securityManager != null) {
            securityManager.checkSecurityAccess(target);
        }
    }
}
